#include "DoubleLinkList.h"


int main(int argc, char* argv[])
{
	int i;
	DuLinkList* pListHead;	// A pointer to the head of a bidirectional circular list,Points to the header node
	DuLinkList* pListNode;	// Bidirectional circular list node pointer
	DuLinkList* pListHeadTemp;
	
	//
	// Initializes a pointer to the head node of a bidirectional circular list
	//
	pListHead = (DuLinkList*)malloc(sizeof(DuLinkList));
	pListHead->prior = pListHead;
	pListHead->next = pListHead;
	
	//
	// Initializes the nodes of a bidirectional circular list
	//
	for(i=8; i>0; i--)
	{
		pListNode = (DuLinkList*)malloc(sizeof(DuLinkList));
		pListNode->data = i;
		
		pListNode->next = pListHead->next;
		pListNode->prior = pListHead;
		pListHead->next->prior = pListNode;		
		pListHead->next = pListNode;
	}
	
	//
	// Insert a node before the ith node
	//
	InsertBefore(pListHead, 3, 88);
	InsertBefore(pListHead, 20, 15);		// Invalid insert position. Insert failed.
	
	pListHeadTemp = pListHead;
	pListNode = pListHeadTemp->next;
	while(pListNode != pListHeadTemp)
	{
		printf("%d ", pListNode->data);
		pListNode = pListNode->next;		
	}
	printf("\n");
	
	//
	// Destroy bidirectional circular linked list
	//
	while(pListHead->next != pListHead)
	{
		pListNode = pListHead->next;
		pListHead->next = pListNode->next;
		pListNode->next->prior = pListHead;
		
		free(pListNode);
	}
	free(pListHead);

	return 0;
}

/*
function:
	Insert a node before the ith node.

parameter:
	pListHead -- A pointer to the head of a bidirectional circular list
	i -- The location of the insertion node.Count from 1.
	Elem -- Insert the value of the node.
	  
returned value:
	Returns 1 if insert succeeds
	Returns 0 if insert fails
*/
int InsertBefore(DuLinkList* pListHead, int i, ElemType Elem)
{
	DuLinkList* pListNode;			// Node pointer
	
	//
	// TODO: Add the code here
	//
	
	return 0;
}
